/*
 * v3 - тест ССР для Pro mini + E19 + BMP280 + MOSFET
 *      только питание на контроллере (см версию 512)
 *      мигает немножко, выводит данные по serial, мигает 15 сек, мигает быстро 5 сек, регистрация 400мс, вкл запала, продолжение регистрации до конца
 *      период регистрации 20мс, общая длительность записи 5 сек
 */


#define _Read 2               //вход, проверяем при вкл. Если 0, то вывод данных

//#define led    13  //светодиод тут
#define led    A0 //11  //светодиод тут
#define LED_PIN  led

//#define ignit  13  // затвор запала
#define _triak  A1 //2 //11 //10  //затвор MOSFET запала (1 - включить)

#include <EEPROM.h>

#define vACC A5       // напряжение АКБ
#define _v_plus A0    // динамик выход  +
#define _v_minus 11   // динамик выход  -
#define tPress 20     //период отсчетов  (мс)  (на 5 сек)
#define nPer 20       //число замеров перед вкл. запала (0,4 сек)
#define maxAddr 1024  //объем EEPROM 
#define maxVCC  4100    //пороговое напряжение питания (мВ)

byte aLow;
byte aHigh;
unsigned int valAlt;
long int valPress;
int addr;
int Nbuf;

long readVcc() {
  // Read 1.1V reference against AVcc
  // set the reference to Vcc and the measurement to the internal 1.1V reference
  
  #if defined(__AVR_ATmega32U4__) || defined(__AVR_ATmega1280__) || defined(__AVR_ATmega2560__)
    ADMUX = _BV(REFS0) | _BV(MUX4) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
  #elif defined (__AVR_ATtiny24__) || defined(__AVR_ATtiny44__) || defined(__AVR_ATtiny84__)
    ADMUX = _BV(MUX5) | _BV(MUX0);
  #elif defined (__AVR_ATtiny25__) || defined(__AVR_ATtiny45__) || defined(__AVR_ATtiny85__)
    ADMUX = _BV(MUX3) | _BV(MUX2);
  #else
    ADMUX = _BV(REFS0) | _BV(MUX3) | _BV(MUX2) | _BV(MUX1);
  #endif  
 
  delay(2); // Wait for Vref to settle
  ADCSRA |= _BV(ADSC); // Start conversion
  while (bit_is_set(ADCSRA,ADSC)); // measuring
 
  uint8_t low  = ADCL; // must read ADCL first - it then locks ADCH  
  uint8_t high = ADCH; // unlocks both
 
  long result = (high<<8) | low;
 
  result = 1125300L / result; // Calculate Vcc (in mV); 1125300 = 1.1*1023*1000
  return result; // Vcc in millivolts
}

void MasToEE(unsigned int tAlt) {
  //запись в EEPROM замера
  EEPROM.write(addr, lowByte(tAlt));
  EEPROM.write(addr+1, highByte(tAlt));
  }

// процедура формирования сигнала 4КГц на 0,06 сек на пьезоизлучателе
void Beep60() { 
  for (int i=0; i<230; i++) {       // циклов примерно на 0,06 сек  
      digitalWrite(_v_plus, HIGH);  // подаем HIGH на выход  +
//      digitalWrite(_v_minus, LOW);  // устанавливаем LOW на выходе  -
      delayMicroseconds(128);       // ожидаем полпериода от 4КГц
      digitalWrite(_v_plus, LOW);   // устанавливаем LOW на выходе  +
//      digitalWrite(_v_minus, HIGH); // подаем HIGH на выход  -
      delayMicroseconds(128);       // ожидаем полпериода от 4КГц
  }
//  digitalWrite(_v_minus, LOW);      // устанавливаем LOW на выходе  - (везде Low)
}



void setup() {
  // initialize the digital pin as an output.
  pinMode(led, OUTPUT);  
  pinMode(_triak, OUTPUT);  
  digitalWrite(_triak,LOW);    //выкл.запал
  pinMode(_v_plus, OUTPUT);   // выход  +
//  pinMode(_v_minus, OUTPUT);  // выход  -
   for (int i=0; i < 3; i++) {
       digitalWrite(led,HIGH);    
       Beep60();
       digitalWrite(led,LOW);    //выкл
       delay(200);
   }  
//проверим напряжение питания
//      valAlt = readVcc();                //питание устройства VCC(5V)    006
//      if (valAlt > maxVCC) {
//        //питаемся от 5В - включать BMP280 нельзя
        
//      pinMode(_Read, INPUT);             //проверка - не надо ли данные считать?
//      digitalWrite(_Read, HIGH);         //вкл pullup
//      if (digitalRead(_Read) == LOW) {

        delay(800);
       digitalWrite(led,HIGH);    
        Beep60();        //два бипа перед выводом
        delay(400);  
       digitalWrite(led,LOW);    
        Beep60();     
        
//--------- начало блока считывания данных из EEPROM -------------  
     Serial.begin(9600);
     Serial.println("Read EEPROM from MC. Ver testIgnit3");
     for (addr=0; addr<maxAddr; addr = addr +2) {
        aLow  = EEPROM.read(addr);
        aHigh = EEPROM.read(addr+1);
        Serial.print(addr);
        Serial.print(";  ");
        Serial.print(aLow+aHigh*256);  //напряж.на контроллере
//        Serial.print(";  ");
//        aLow  = EEPROM.read(addr+2);
//        aHigh = EEPROM.read(addr+3);
//        Serial.print(aLow+aHigh*256);  //напряж на АКБ
        Serial.print(";  ");
        Serial.println();
      }
     Serial.println("The End Read EEPROM");

//   while(1) {
//       digitalWrite(led,HIGH);    
//       Beep60();
//       digitalWrite(led,LOW);    
//       delay(1440);
//   }  


     
      
//------- окончание блока считывания ------------------  

addr = 0;
Nbuf = 0;
//индикатор начала фиксации напряжения 10 медленных по 1,5 сек (15 сек)

   for (int i=0; i < 10; i++) {
       digitalWrite(led,HIGH);    
       Beep60();
       digitalWrite(led,LOW);    
       delay(1440);
   }  
   //пауза перед началом эксперимента  10 быстрых (0,5 сек) на 5 сек   
   for (int i=0; i < 10; i++) {
       digitalWrite(led,HIGH);    
       Beep60();
       digitalWrite(led,LOW);    
       delay(440);
   }  
}

void loop() {
  long int tTek = millis();
  
   Nbuf++;
   if (Nbuf >= nPer) {
     digitalWrite(_triak,HIGH);   //вкл.запал
       digitalWrite(led,HIGH);    
   }
     //делаем замер
     valAlt = readVcc();  //это напр при выкл ПРД
     MasToEE(valAlt);  //запись в EEPROM 
     
     addr = addr + 2;
      
//     valAlt = analogRead(vACC);      //на аккумуляторе
//     MasToEE(valAlt);  //запись в EEPROM 

//     addr = addr + 2;

  if (addr >= maxAddr)  {
    digitalWrite(_triak,LOW);    //выкл.запал
//останов
    while (1) {  //непрерывно передаем "пяти-точие" 
       for (int i=0; i < 5; i++) {
       digitalWrite(led,HIGH);    
          Beep60();
       digitalWrite(led,LOW);    
          delay(240);
       }  
       delay(700);
   } 
  }
    
  while ((tTek + tPress) > millis()) {} 
}
